#include <system.h>
#include "frequency2.h"

/*--------------------------------------------------------------------
  Convert a binary number 0..4,294,967,295 to an ascii string.
  Modified to process 0..9,999,999 for this application.
  ptr must point to a 8 (or more) character string for result.
--------------------------------------------------------------------*/
void ltoa( unsigned long num, char *ptr )
{
  char			ii=0, flag=0;
  unsigned long dig;

#if 0  
  if ( num > 999999999 )
  {
    // Process billions digit
    dig = num / 1000000000;
    ptr[ii] = (unsigned char) dig + 0x30;
    ++ii;
    num -= ( dig * 1000000000 );
    flag = 1;
  }
  
  if ( num > 99999999 )
  {
    // Process hundred millions digit
    dig = num / 100000000;
    ptr[ii] = (unsigned char) dig + 0x30;
    ++ii;
    num -= ( dig * 100000000 );
    flag = 1;
  }
  else
    if ( flag )
    {
      ptr[ii] = '0';
      ++ii;
    }
  
  if ( num > 9999999 )
  {
    // Process ten millions digit
    dig = num / 10000000;
    ptr[ii] = (unsigned char) dig + 0x30;
    ++ii;
    num -= ( dig * 10000000 );
    flag = 1;
  }
  else
    if ( flag )
    {
      ptr[ii] = '0';
      ++ii;
    }
#endif
  
  if ( num > 999999 )
  {
    // Process millions digit
    dig = num / 1000000;
    ptr[ii] = (unsigned char) dig + 0x30;
    ++ii;
    num -= ( dig * 1000000 );
    flag = 1;
  }
  else
    if ( flag )
    {
      ptr[ii] = '0';
      ++ii;
    }

  if ( num > 99999 )
  {
    // Process hundred thousands digit
    dig = num / 100000;
    ptr[ii] = (unsigned char) dig + 0x30;
    ++ii;
    num -= ( dig * 100000 );
    flag = 1;
  }
  else
    if ( flag )
    {
      ptr[ii] = '0';
      ++ii;
    }
  
  if ( num > 9999 )
  {
    // Process ten thousands digit
    dig = num / 10000;
    ptr[ii] = (unsigned char) dig + 0x30;
    ++ii;
    num -= ( dig * 10000 );
    flag = 1;
  }
  else
    if ( flag )
    {
      ptr[ii] = '0';
      ++ii;
    }
  
  if ( num > 999 )
  {
    // Process thousands digit
    dig = num / 1000;
    ptr[ii] = (unsigned char) dig + 0x30;
    ++ii;
    num -= ( dig * 1000 );
    flag = 1;
  }
  else
    if ( flag )
    {
      ptr[ii] = '0';
      ++ii;
    }
  
  if ( num > 99 )
  {
    // Process hundreds digit
    dig = num / 100;
    ptr[ii] = (unsigned char) dig + 0x30;
    ++ii;
    flag = 1;
    num -= ( dig * 100 );
  }
  else
    if ( flag )
    {
      ptr[ii] = '0';
      ++ii;
    }
    
  if ( num > 9 )
  {
    // Process tens digit
    dig = num / 10;
    ptr[ii] = (unsigned char) dig + 0x30;
    ++ii;
    num -= ( dig * 10 );
  }
  else
    if ( flag )
    {
      ptr[ii] = '0';
      ++ii;
    }

  // Process ones digit
  ptr[ii] = (unsigned char) num + 0x30;
  ++ii;
  ptr[ii] = '\0';
}
